/*********************************************************************/
/* ARDUINO SNAKE by Walkone
/* 2016.4 */




#include <Wire.h>
#include <I2C_LCD.h>
I2C_LCD LCD;
uint8_t I2C_LCD_ADDRESS = 0x51;

#define delayms 400

// display width and height
#define SW 124
#define SH 52   //63-8-1
// generate food within the field with inset padding
#define PADDING 20
// snake size 4px
#define W 4
// constants for movement
#define TOP 1
#define BOTTOM 3
#define LEFT 4
#define RIGHT 2
// maximum length of snake
#define MAXLEN 50
// current/start length of snake
int length = 5;

int direction;
int direction_old;
int currentx;
int currenty;
int lastx;
int lasty;
int foodx;
int foody;
int posx[MAXLEN];
int posy[MAXLEN];
int n;
int Cnt;
int Score;

// button 
 #define Left 0
 #define Right 1
 int joyPin1 = 0;                 // slider variable connecetd to analog pin 0
 int joyPin2 = 1;                 // slider variable connecetd to analog pin 1
 int value1 = 0;                  // variable to read the value from the analog pin 0
 int value2 = 0;                  // variable to read the value from the analog pin 1
 int GameOver;

void InitGame(void);

void setup(void) 
{
  Wire.begin();           //I2C controller initialization
  Serial.begin(9600);
 
  LCD.CleanAll(WHITE); ////clear screen for white
  LCD.FontModeConf(Font_12x24, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Snake",34,0); //display Snake
  LCD.DrawHLineAt(0,127,22, BLACK);
  LCD.FontModeConf(Font_8x16_1, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Game",44,22); //display Game
  delay(delayms); //delay 2s
   LCD.CleanAll(WHITE); //clear screen for white
   delay(delayms); //delay 2s
  LCD.FontModeConf(Font_12x24, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Snake",34,0); //display Snake
  LCD.DrawHLineAt(0,127,22, BLACK);
  LCD.FontModeConf(Font_8x16_1, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Game",44,22); //display Game
  delay(delayms); //delay 2s
   LCD.CleanAll(WHITE); //clear screen for white
   delay(delayms); //delay 2s
  LCD.FontModeConf(Font_12x24, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Snake",34,0); //display Snake
  LCD.DrawHLineAt(0,127,22, BLACK);
  LCD.FontModeConf(Font_8x16_1, FM_ANL_AAA, BLACK_BAC);
  LCD.DispStringAt("Game",44,22); //display Game
//  while(1);
  InitGame();
  GameOver = 1;
  LCD.DispStringAt("Down key to start",14,22); //display "Down key to start"
}

void InitGame(void)
{
  LCD.CleanAll(WHITE); //clear screen for white
  LCD.FontModeConf(Font_6x8, FM_ANL_AAA, BLACK_BAC);
 
  LCD.DrawVLineAt(3, 52, 3, BLACK);
  LCD.DrawHLineAt(3,124,52, BLACK);
  LCD.DrawVLineAt(3, 52, 124, BLACK);
  LCD.DrawHLineAt(3,124, 3, BLACK); 
//while(1);
  direction = LEFT;
  direction_old = TOP;
  genFood();
  currentx = 96;
  currenty = 32;
  lastx = 96;
  lasty = 32;
  length = 5;
   
  for(int i=0;i<MAXLEN;i++){
     posx[i] = 0;
     posy[i] = 0;
  }

  n = 0;
  Cnt = 10;
  LCD.DispStringAt("Score",1,55); //Score
  Score = 50;
 }

void refreshDisplay(void){
  // ********** direction **********
  int dirx = 0;
  int diry = 0;

  if((direction+direction_old)%2 == 0){
    //LCD.DispStringAt("Dir Err",26,32); //Dierection err
  direction = direction_old;
  }
  //Serial.print("*");
  //Serial.print(direction_old,DEC);
 
  switch(direction){
    case RIGHT:
       dirx = W;
       diry = 0;

       break; 
       
    case LEFT:
       dirx = -W;
       diry = 0;
    
       break;
       
    case BOTTOM:
       dirx = 0;
       diry = W;
    
       break;
       
    case TOP:
       dirx = 0;
       diry = -W;
    
       break;
  }
  
  // ********** current position **********
  currentx += dirx;
  currenty += diry;  
  if(currentx>=SW){
    LCD.DispStringAt("Game Over.",32,32); //Game Over
     GameOver = 1;
     delay(1000);
  }else if(currentx<=0){
    LCD.DispStringAt("Game Over..",32,32); //Game Over
     GameOver = 2;
     delay(1000);
//     currentx = SW;
  }
  
  if(currenty>=SH){    
    LCD.DispStringAt("Game Over...",32,32); //Game Over
    GameOver = 3;
    delay(1000);
    //currenty = 0;
  } else if(currenty<=0){
     LCD.DispStringAt("Game Over....",32,32); //Game Over
     GameOver = 4;
     delay(1000);
//     currenty = SH;

  }
    Serial.print(currentx,DEC);
    Serial.print(",");
    Serial.println(currenty,DEC);
    if(GameOver == 0){
    LCD.DrawRectangleAt(currentx, currenty, W, W, BLACK_FILL); 
    }  
  // ********** food **********
  LCD.DrawRectangleAt(foodx, foody, W,W, BLACK_FILL);

  if(currentx == foodx && currenty == foody)
  {
    genFood();     
    length+=1;
    Score +=10;
  }
  
  if(n==length){
    n = 0;
  }
  
  posx[n] = currentx;
  posy[n] = currenty;
  
  if(GameOver == 0){
  n++;
  }
  
  // ********** remove tail **********
  int lastn = n-length;
  if(lastn<0){
    lastn = length+lastn;
  }
  lastx = posx[lastn];
  lasty = posy[lastn];
  
//  display.fillRect(lastx, lasty, W, W, WHITE);
    if(GameOver == 0){
      if(lastx == 0 && lasty == 0){
      ;
      }
      else{
      LCD.DrawRectangleAt(lastx, lasty, W, W, WHITE_FILL);
      }
    }

//for test
//    Serial.print(lastx,DEC);
//    Serial.print(",");
//    Serial.println(lasty,DEC);
//    Cnt -= 1;                
//    if(Cnt == 0){
//    while(1);
//    }
 } 

void loop(void) 
{
  int buttonState = HIGH; 
  int buttonState2 = HIGH; 
  // ********** buttons LEFT+RIGHT **********
// reads the value of the variable resistor 
  value1 = analogRead(joyPin1);   
  // this small pause is needed between reading
  // analog pins, otherwise we get the same value twice
  delay(20);             
  // reads the value of the variable resistor 
  value2 = analogRead(joyPin2); 

//  Serial.print(value1,DEC);
//  Serial.print(",");
///  Serial.println(value2,DEC);

// ********** Button click changes direction of Snake *********
  if(value1>350&&value2>600)     //up   (510,760)
  {    
       if(direction == TOP){
        direction = direction;
        }
        else{
       direction_old = direction;
       direction = TOP; 
        }
  }
  else if(value1>350&&value2<300)    //down
  {             
        if(direction == BOTTOM){
        direction = direction;
        }
        else{
        direction_old = direction;
        direction = BOTTOM;
        }
        // Restart Game
        if(GameOver != 0){
        GameOver = 0;
        InitGame();
        }
  }
  else if(value1<300&&value2>200)    //left
  {
        if(direction == LEFT){
        direction = direction;
        }
        else{
        direction_old = direction;
        direction = LEFT;
        }
  }
  else if(value1>550&&value2>250)    //right
  {
        if(direction == RIGHT){
        direction = direction;
        }
        else{
        direction_old = direction;
        direction = RIGHT;
        }
  }
//  Serial.print(direction,DEC);
// Serial.print(",");

    
    delay(140);
    if(GameOver == 0){
    refreshDisplay();
    }
    LCD.CharGotoXY(36,55);
    LCD.print(Score,DEC);
    
}

// ********** Food **********
void genFood(void){
   foodx = random(W,SW-W-W);
   foody = random(W,SH-W-W);
//   Serial.print(foodx,DEC);
 //   Serial.print(",");
//    Serial.println(foody,DEC);
   if((foodx &1)){
     foodx+=3;
   }
   if((foody & 1)){
     foody+=3;                                                                                                           ;
   }
   if((foodx &2)){
     foodx+=2;
   }
   if((foody & 2)){
     foody+=2;                                                                                                           ;
   }

//   Serial.print(foodx,DEC);
//    Serial.print(",");
//    Serial.println(foody,DEC);
}
